Index: branches/RWT/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- trunk/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 468)
+++ branches/RWT/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 477)
@@ -2272,6 +2629,16 @@
         r_read_to_tgt_rsp_length = m_cmd_read_length_fifo.read();
         r_read_to_tgt_rsp_srcid  = m_cmd_read_srcid_fifo.read();
+        /*RWT*/
+        //BUG pktid
+        if (r_read_coherent.read())
+        {
+          r_read_to_tgt_rsp_pktid = 0x0 + m_cmd_read_pktid_fifo.read();
+          //std::cout << "READ RSP COHERENT on word" << std::hex << m_x[(addr_t) m_cmd_read_addr_fifo.read()] << std::dec << std::endl;
+        }
+        else
+        {
+          r_read_to_tgt_rsp_pktid = 0x8 + m_cmd_read_pktid_fifo.read();
+        }
         r_read_to_tgt_rsp_trdid  = m_cmd_read_trdid_fifo.read();
-        r_read_to_tgt_rsp_pktid  = m_cmd_read_pktid_fifo.read();
         r_read_to_tgt_rsp_ll_key = r_read_ll_key.read();
         cmd_read_fifo_get        = true;
@@ -2302,5 +2669,8 @@
         if(hit_read or !wok or hit_write)    // missing line already requested or no space
         {
-          if(!wok)      m_cpt_trt_full++;
+          if(!wok)
+          {
+            m_cpt_trt_full++;
+          }
           if(hit_read or hit_write)   m_cpt_trt_rb++;
           r_read_fsm = READ_IDLE;
@@ -2319,6 +2689,10 @@
           << " / hit_write = " << hit_write
           << " / full = " << !wok << std::endl;
-#endif
-      }
+        m_cpt_read_fsm_n_trt_lock++;
+#endif
+      }
+
+      m_cpt_read_fsm_trt_lock++;
+
       break;
     }
@@ -2341,4 +2715,5 @@
                               std::vector<data_t> (m_words,0),
                               r_read_ll_key.read());
+        
 #if DEBUG_MEMC_READ
 if(m_debug)
@@ -2507,5 +2882,5 @@
       {
         ///////////////////////////////////////////////////////////////////////
-        // SC command treatment
+        // SC command handling
         // We test the r_write_pending_sc register to know if we are returning
         // from the WAIT state.
@@ -2513,28 +2888,33 @@
         // another time from the FIFO. Also, we don't have to test another
         // time if the SC has succeed
+
+        addr_t nline = m_nline[(addr_t)(r_write_address.read())];
         if(((r_write_pktid.read() & 0x7) == TYPE_SC) and not r_write_pending_sc.read())
         {
           if(not m_cmd_write_addr_fifo.rok()) break;
-
+  
           assert(m_cmd_write_eop_fifo.read() and
                  "Error in VCI_MEM_CACHE : "
                  "invalid packet format for SC command");
-
+          //BUG LLSC
           size_t index    = r_write_word_index.read();
-          bool sc_success = m_llsc_table.sc(r_write_address.read()    ,
+          bool sc_success = m_llsc_table.sc(nline    ,
                                             r_write_data[index].read());
-
+  
+          //bool sc_success = m_llsc_table.sc(r_write_address.read()    ,
+          //                                  r_write_data[index].read());
           // consume a word in the FIFO & write it in the local buffer
           cmd_write_fifo_get  = true;
           r_write_data[index] = m_cmd_write_data_fifo.read();
           r_write_sc_fail     = not sc_success;
+          //WARNING: if the SC is a success, it might still fail at next cycle if the line is NCC
           r_write_pending_sc  = true;
-
+  
           if(not sc_success) r_write_fsm = WRITE_RSP;
           else               r_write_fsm = WRITE_DIR_LOCK;
-
+  
           break;
         }
-
+  
         ///////////////////////////////////////////////////////////////////////
         // WRITE command treatment or SC command returning from the WAIT state
@@ -2542,7 +2922,10 @@
         // erase any possible new reservation when we release the lock on the
         // directory
-        m_llsc_table.sw(r_write_address.read());
+        m_llsc_table.sw(nline);
+
+        //m_llsc_table.sw(r_write_address.read());
 
         r_write_fsm = WRITE_DIR_LOCK;
+        m_cpt_write_fsm_n_dir_lock++;
       }
 
@@ -2552,4 +2935,6 @@
           << std::endl;
 #endif
+
+      m_cpt_write_fsm_dir_lock++;
 
       break;
@@ -2578,17 +2963,37 @@
           r_write_ptr        = entry.ptr;
           r_write_way        = way;
-
-          if(entry.is_cnt and entry.count)
+          
+          r_write_coherent   = entry.cache_coherent;
+
+          if (entry.cache_coherent or (entry.owner.srcid == r_write_srcid.read()) or (entry.count == 0)) // hit WT
           {
-            r_write_fsm = WRITE_DIR_READ;
+            if(entry.is_cnt && entry.count)
+            {
+              r_write_fsm = WRITE_DIR_READ;
+            }
+            else
+            {
+             r_write_fsm = WRITE_DIR_HIT;
+            }
           }
           else
           {
-            r_write_fsm = WRITE_DIR_HIT;
+            if (r_write_to_cleanup_req.read())//inval already sent
+            {
+              r_write_fsm = WRITE_WAIT;
+            }
+            else // hit on a NCC line with a different owner
+            {
+              r_write_fsm = WRITE_IVT_LOCK_HIT_WB;
+              if(r_write_pktid.read() == TYPE_SC)
+              {
+                r_write_sc_fail = true;
+              }
+            }
           }
         }
         else  // miss
         {
-          r_write_fsm = WRITE_MISS_TRT_LOCK;
+          r_write_fsm = WRITE_MISS_IVT_LOCK;
         }
 
@@ -2619,4 +3024,58 @@
     }
     ////////////////////
+    case WRITE_IVT_LOCK_HIT_WB:
+    {
+      if(r_alloc_ivt_fsm.read() == ALLOC_IVT_WRITE)
+      {
+
+        size_t index = 0;
+        bool   match_inval;
+        addr_t nline = m_nline[(addr_t)(r_write_address.read())];
+
+        //std::cout << "WRITE on NCC on line" << std::hex << nline << std::dec << std::endl;
+
+        match_inval = m_upt.search_inval(nline, index);
+        assert ((r_write_count.read() == 1) and "NCC to CC req without copy");
+        if(!match_inval and !r_write_to_cc_send_req.read())
+        {
+          r_write_to_cc_send_req = true;
+          r_write_to_cc_send_dest = r_write_copy;
+          r_write_to_cc_send_nline = nline;
+          r_write_to_cleanup_req = true;
+          r_write_to_cleanup_nline = nline;
+
+          m_upt.set(false,  // it's an inval transaction
+                          false,     // it's not a broadcast
+                          true,      // it needs no read response
+                          false,     // no acknowledge required
+                          m_cmd_write_srcid_fifo.read(), //never read, used for debug
+                          m_cmd_write_trdid_fifo.read(), //never read, used for debug
+                          m_cmd_write_pktid_fifo.read(), //never read, used for debug
+                          nline,
+                          0x1, //Expect only one answer
+                          index);
+        }
+        r_write_fsm = WRITE_WAIT;
+#if DEBUG_MEMC_WRITE
+        if(m_debug)
+        {
+          std::cout << "  <MEMC " << name() << " WRITE_IVT_LOCK_HIT_WB> get access to the UPT: "
+                    << " Inval requested =  " << (!match_inval and !r_write_to_cc_send_req.read())
+                    << std::endl;
+        }
+#endif
+      }
+#if DEBUG_MEMC_WRITE
+        if(m_debug)
+        {
+          std::cout << "  <MEMC " << name() << " WRITE_IVT_LOCK_HIT_WB> failed to access to the UPT: "
+                    << std::endl;
+        }
+#endif
+      break;
+    }
+
+
+    ////////////////////
     case WRITE_DIR_READ:  // read the cache and complete the buffer when be!=0xF
     {
@@ -2656,4 +3115,5 @@
       DirectoryEntry entry;
       entry.valid          = true;
+      entry.cache_coherent = r_write_coherent.read();
       entry.dirty          = true;
       entry.tag            = r_write_tag.read();
@@ -2683,10 +3143,10 @@
       // no_update is true when there is no need for coherence transaction
       // (tests for sc requests)
-      bool no_update = ( (r_write_count.read() == 0) or
-                         (owner and (r_write_count.read() ==1) and 
-                         (r_write_pktid.read() != TYPE_SC)));
+      bool no_update = ((r_write_count.read() ==0) || //no need for coherency
+                        (owner && (r_write_count.read() ==1) && (r_write_pktid.read() != TYPE_SC)) || //writer is owner
+                        ((r_write_pktid.read() == TYPE_SC) && r_write_sc_fail.read())); //SC failed: no data update
 
       // write data in the cache if no coherence transaction
-      if(no_update)
+      if(no_update and ((r_write_pktid.read() != TYPE_SC) or !r_write_sc_fail.read()))
       {
         for(size_t word=0 ; word<m_words ; word++)
@@ -2760,4 +3220,5 @@
         size_t      set        = m_y[(addr_t)(r_write_address.read())];
         size_t      way        = r_write_way.read();
+
 
         wok = m_upt.set(true,  // it's an update transaction
@@ -2804,5 +3265,9 @@
         if(wok) r_write_fsm = WRITE_UPT_HEAP_LOCK;
         else    r_write_fsm = WRITE_WAIT;
-      }
+        m_cpt_write_fsm_n_upt_lock++;
+      }
+
+      m_cpt_write_fsm_upt_lock++;
+
       break;
     }
@@ -2820,5 +3285,9 @@
 #endif
         r_write_fsm = WRITE_UPT_REQ;
-      }
+        m_cpt_write_fsm_n_heap_lock++;
+      }
+
+      m_cpt_write_fsm_heap_lock++;
+
       break;
     }
@@ -2834,4 +3303,5 @@
              "transaction in WRITE_UPT_REQ state"
             );
+
 
       r_write_to_cc_send_brdcast_req  = false;
@@ -3070,4 +3540,21 @@
       break;
     }
+    ///////////////////////// RWT
+    case WRITE_MISS_IVT_LOCK: // Miss : check UPT 
+    {
+      if (r_alloc_ivt_fsm.read() == ALLOC_IVT_WRITE)
+      {
+        size_t index;
+        if(m_upt.search_inval(m_nline[(addr_t)(r_write_address.read())], index))
+        {
+          r_write_fsm = WRITE_WAIT;
+        }
+        else
+        {
+          r_write_fsm = WRITE_MISS_TRT_LOCK;
+        }
+      }
+      break;
+    }
 
     /////////////////////////
@@ -3087,5 +3574,5 @@
         bool    hit_write = m_trt.hit_write(m_nline[addr]);
         bool    wok       = !m_trt.full(wok_index);
-
+        //std::cout << "MEMCACHE : WRITE MISS at " << std::hex << (uint32_t)addr << std::dec << std::endl;
         if(hit_read)      // register the modified data in TRT
         {
@@ -3105,5 +3592,9 @@
           m_cpt_trt_full++;
         }
-      }
+        m_cpt_write_fsm_n_trt_lock++;
+      }
+
+      m_cpt_write_fsm_trt_lock++;
+
       break;
     }
@@ -3224,5 +3715,9 @@
           << " : wok = " << wok << " / index = " << wok_index << std::endl;
 #endif
-      }
+        m_cpt_write_fsm_n_trt_lock++;
+      }
+
+      m_cpt_write_fsm_trt_lock++;
+
       break;
     }
@@ -3251,5 +3746,5 @@
                         nb_copies,
                         index);
-
+       /*ODCCP*/ //m_upt.print();
 #if DEBUG_MEMC_WRITE
 if( m_debug and wok )
@@ -3261,5 +3756,9 @@
         if(wok) r_write_fsm = WRITE_BC_DIR_INVAL;
         else    r_write_fsm = WRITE_WAIT;
-      }
+        m_cpt_write_fsm_n_upt_lock++;
+      }
+
+      m_cpt_write_fsm_upt_lock++;
+
       break;
     }
@@ -3295,4 +3794,5 @@
       DirectoryEntry entry;
       entry.valid         = false;
+      entry.cache_coherent= false;
       entry.dirty         = false;
       entry.tag         = 0;
@@ -3394,38 +3894,43 @@
     ////////////////////////
     case IXR_CMD_READ_IDLE:
-    {
       if     (r_write_to_ixr_cmd_req)    r_ixr_cmd_fsm = IXR_CMD_WRITE;
       else if(r_cas_to_ixr_cmd_req)      r_ixr_cmd_fsm = IXR_CMD_CAS;
       else if(r_xram_rsp_to_ixr_cmd_req) r_ixr_cmd_fsm = IXR_CMD_XRAM;
+      else if(r_cleanup_to_ixr_cmd_req)  r_ixr_cmd_fsm = IXR_CMD_CLEANUP_DATA;
       else if(r_read_to_ixr_cmd_req)     r_ixr_cmd_fsm = IXR_CMD_READ;
       break;
-    }
     ////////////////////////
     case IXR_CMD_WRITE_IDLE:
-    {
-      if     (r_cas_to_ixr_cmd_req)      r_ixr_cmd_fsm = IXR_CMD_CAS;
+      if(r_cas_to_ixr_cmd_req)           r_ixr_cmd_fsm = IXR_CMD_CAS;
       else if(r_xram_rsp_to_ixr_cmd_req) r_ixr_cmd_fsm = IXR_CMD_XRAM;
+      else if(r_cleanup_to_ixr_cmd_req)  r_ixr_cmd_fsm = IXR_CMD_CLEANUP_DATA;
       else if(r_read_to_ixr_cmd_req)     r_ixr_cmd_fsm = IXR_CMD_READ;
       else if(r_write_to_ixr_cmd_req)    r_ixr_cmd_fsm = IXR_CMD_WRITE;
       break;
-    }
     ////////////////////////
     case IXR_CMD_CAS_IDLE:
-    {
-      if     (r_xram_rsp_to_ixr_cmd_req) r_ixr_cmd_fsm = IXR_CMD_XRAM;
+      if(r_xram_rsp_to_ixr_cmd_req)      r_ixr_cmd_fsm = IXR_CMD_XRAM;
+      else if(r_cleanup_to_ixr_cmd_req)  r_ixr_cmd_fsm = IXR_CMD_CLEANUP_DATA;
       else if(r_read_to_ixr_cmd_req)     r_ixr_cmd_fsm = IXR_CMD_READ;
       else if(r_write_to_ixr_cmd_req)    r_ixr_cmd_fsm = IXR_CMD_WRITE;
       else if(r_cas_to_ixr_cmd_req)      r_ixr_cmd_fsm = IXR_CMD_CAS;
       break;
-    }
     ////////////////////////
     case IXR_CMD_XRAM_IDLE:
-    {
-      if     (r_read_to_ixr_cmd_req)     r_ixr_cmd_fsm = IXR_CMD_READ;
-      else if(r_write_to_ixr_cmd_req)    r_ixr_cmd_fsm = IXR_CMD_WRITE;
+      if(r_cleanup_to_ixr_cmd_req)     r_ixr_cmd_fsm = IXR_CMD_CLEANUP_DATA;
+      else if(r_read_to_ixr_cmd_req)     r_ixr_cmd_fsm = IXR_CMD_READ;
+      else if(r_write_to_ixr_cmd_req)     r_ixr_cmd_fsm = IXR_CMD_WRITE;
       else if(r_cas_to_ixr_cmd_req)      r_ixr_cmd_fsm = IXR_CMD_CAS;
       else if(r_xram_rsp_to_ixr_cmd_req) r_ixr_cmd_fsm = IXR_CMD_XRAM;
       break;
-    }
+      ////////////////////////
+    case IXR_CMD_CLEANUP_IDLE:
+      /*ODCCP*///std::cout << "IXR_CMD_CLEANUP_IDLE" << std::endl;
+      if(r_read_to_ixr_cmd_req)     r_ixr_cmd_fsm = IXR_CMD_READ;
+      else if(r_write_to_ixr_cmd_req)     r_ixr_cmd_fsm = IXR_CMD_WRITE;
+      else if(r_cas_to_ixr_cmd_req)      r_ixr_cmd_fsm = IXR_CMD_CAS;
+      else if(r_xram_rsp_to_ixr_cmd_req) r_ixr_cmd_fsm = IXR_CMD_XRAM;
+      else if(r_cleanup_to_ixr_cmd_req)     r_ixr_cmd_fsm = IXR_CMD_CLEANUP_DATA;
+      break;      
     //////////////////       // send a get from READ FSM
     case IXR_CMD_READ:
@@ -3553,4 +4058,30 @@
       break;
     }
+
+      ////////////////////////
+    case IXR_CMD_CLEANUP_DATA:     // send a put command to XRAM
+      /*ODCCP*///std::cout << "IXR_CMD_CLEANUP_DATA" << std::endl;
+      if(p_vci_ixr.cmdack)
+      {
+        if(r_ixr_cmd_cpt.read() == (m_words - 2))
+        {
+          r_ixr_cmd_cpt = 0;
+          r_ixr_cmd_fsm = IXR_CMD_CLEANUP_IDLE;
+          r_xram_rsp_to_ixr_cmd_inval_ncc_pending = false;
+          r_cleanup_to_ixr_cmd_req = false;
+        }
+        else
+        {
+          r_ixr_cmd_cpt = r_ixr_cmd_cpt.read() + 2;
+        }
+
+#if DEBUG_MEMC_IXR_CMD
+        if(m_debug)
+        {
+          std::cout << "  <MEMC " << name() << ".IXR_CMD_CLEANUP_DATA> Send a put request to xram" << std::endl;
+        }
+#endif
+      }
+      break;
 
   } // end switch r_ixr_cmd_fsm
@@ -3631,5 +4162,9 @@
           << r_ixr_rsp_trt_index.read() << std::endl;
 #endif
-      }
+      m_cpt_ixr_fsm_n_trt_lock++;
+      }
+
+      m_cpt_ixr_fsm_trt_lock++;
+
       break;
     }
@@ -3667,5 +4202,7 @@
           << " / data = " << std::hex << data << std::endl;
 #endif
-      }
+      m_cpt_ixr_fsm_n_trt_lock++;
+      }
+      m_cpt_ixr_fsm_trt_lock++;
       break;
     }
@@ -3740,5 +4277,9 @@
           << " Get access to DIR and TRT" << std::endl;
 #endif
-      }
+        m_cpt_xram_rsp_fsm_n_dir_lock++;
+        m_cpt_xram_rsp_fsm_n_trt_lock++;
+      }
+      m_cpt_xram_rsp_fsm_dir_lock++;
+      m_cpt_xram_rsp_fsm_trt_lock++;
       break;
     }
@@ -3756,5 +4297,6 @@
         DirectoryEntry victim(m_cache_directory.select(set, way));
 
-        bool inval = (victim.count and victim.valid) ;
+        bool inval = (victim.count && victim.valid) or (!victim.cache_coherent and (victim.count == 1)) ;
+
 
         // copy the victim line in a local buffer
@@ -3766,4 +4308,5 @@
         r_xram_rsp_victim_copy_cache= victim.owner.cache_id;
 #endif
+        r_xram_rsp_victim_coherent  = victim.cache_coherent;
         r_xram_rsp_victim_copy_inst = victim.owner.inst;
         r_xram_rsp_victim_count     = victim.count;
@@ -3774,9 +4317,17 @@
         r_xram_rsp_victim_is_cnt    = victim.is_cnt;
         r_xram_rsp_victim_inval     = inval ;
-        r_xram_rsp_victim_dirty     = victim.dirty;
+        r_xram_rsp_victim_dirty     = victim.dirty or (!victim.cache_coherent && (victim.count == 1)); //a NCC line is by default considered as dirty in the L1: we must take a reservation on a TRT entry
+
 
         if(!r_xram_rsp_trt_buf.rerror)
         {
-          r_xram_rsp_fsm = XRAM_RSP_INVAL_LOCK;
+          if (!victim.cache_coherent and r_xram_rsp_to_ixr_cmd_inval_ncc_pending.read()) //there can not be two L2 invalidation on NCC line at the same time
+          {
+            r_xram_rsp_fsm = XRAM_RSP_INVAL_WAIT;
+          }
+          else
+          {
+            r_xram_rsp_fsm = XRAM_RSP_INVAL_LOCK;
+          }
         }
         else
@@ -3808,5 +4359,7 @@
       {
         size_t index = 0;
-        if(m_ivt.search_inval(r_xram_rsp_trt_buf.nline, index))  // pending inval
+        size_t index_victim = 0;
+        if(m_ivt.search_inval(r_xram_rsp_trt_buf.nline, index) or
+           m_ivt.search_inval(r_xram_rsp_victim_nline.read(), index_victim))
         {
           r_xram_rsp_fsm = XRAM_RSP_INVAL_WAIT;
@@ -3824,4 +4377,5 @@
         {
           r_xram_rsp_fsm = XRAM_RSP_INVAL_WAIT;
+          m_upt.print();
 
 #if DEBUG_MEMC_XRAM_RSP
@@ -3841,5 +4395,9 @@
 #endif
         }
-      }
+        m_cpt_xram_rsp_fsm_n_upt_lock++;
+      }
+
+      m_cpt_xram_rsp_fsm_upt_lock++;
+
       break;
     }
@@ -3891,4 +4449,5 @@
       DirectoryEntry entry;
       entry.valid   = true;
+      entry.cache_coherent = (inst_read or (not(cached_read))) and (r_xram_rsp_trt_buf.proc_read);
       entry.is_cnt  = false;
       entry.lock    = false;
@@ -3907,5 +4466,5 @@
       else
       {
-        entry.owner.srcid    = 0;
+        entry.owner.srcid    = r_xram_rsp_trt_buf.srcid;
 #if L1_MULTI_CACHE
         entry.owner.cache_id = 0;
@@ -3915,5 +4474,6 @@
       }
       m_cache_directory.write(set, way, entry);
-
+      //RWT: keep the coherence information in order to send it to the read_rsp
+      r_xram_rsp_coherent = inst_read or (not(cached_read));
       // request an invalidattion request in IVT for victim line
       if(r_xram_rsp_victim_inval.read())
@@ -3922,5 +4482,5 @@
         size_t index        = 0;
         size_t count_copies = r_xram_rsp_victim_count.read();
-
+  
         bool   wok = m_ivt.set(false,      // it's an inval transaction
                                broadcast,  // set broadcast bit
@@ -3935,5 +4495,4 @@
 
         r_xram_rsp_ivt_index = index;
-
         if(!wok)
         {
@@ -3943,5 +4502,9 @@
         }
       }
-
+      if (!r_xram_rsp_victim_coherent.read())
+      {
+        //m_llsc_table.sw(r_xram_rsp_victim_nline.read()*m_words*4);
+        m_llsc_table.sw(r_xram_rsp_victim_nline.read());
+      }
 #if DEBUG_MEMC_XRAM_RSP
 if(m_debug)
@@ -3962,10 +4525,10 @@
 #endif
 
-      // If the victim is not dirty, we don't need another XRAM put transaction,
+      // If the victim is not dirty (RWT: if it is not coherent, we can not know wether it is dirty or not), we don't need another XRAM  put transaction,
       // and we can erase the TRT entry
-      if(!r_xram_rsp_victim_dirty.read())  m_trt.erase(r_xram_rsp_trt_index.read());
+      if(!r_xram_rsp_victim_dirty.read() and (r_xram_rsp_victim_coherent.read() or (r_xram_rsp_victim_count.read() == 0)))  m_trt.erase(r_xram_rsp_trt_index.read());
 
       // Next state
-      if(r_xram_rsp_victim_dirty.read())       r_xram_rsp_fsm = XRAM_RSP_TRT_DIRTY;
+      if(r_xram_rsp_victim_dirty.read() or (!r_xram_rsp_victim_coherent.read() and (r_xram_rsp_victim_count.read() == 1)))       r_xram_rsp_fsm = XRAM_RSP_TRT_DIRTY;
       else if(r_xram_rsp_trt_buf.proc_read)    r_xram_rsp_fsm = XRAM_RSP_DIR_RSP;
       else if(r_xram_rsp_victim_inval.read())  r_xram_rsp_fsm = XRAM_RSP_INVAL;
@@ -3974,8 +4537,9 @@
     }
     ////////////////////////
-    case XRAM_RSP_TRT_DIRTY:  // set the TRT entry (PUT to XRAM) if the victim is dirty
+    case XRAM_RSP_TRT_DIRTY:  // set the TRT entry (write to XRAM) if the victim is dirty or not coherent (RWT)
     {
       if(r_alloc_trt_fsm.read() == ALLOC_TRT_XRAM_RSP)
       {
+
         m_trt.set(r_xram_rsp_trt_index.read(),
                               false,       // write to XRAM
@@ -3999,5 +4563,9 @@
         else if(r_xram_rsp_victim_inval.read())  r_xram_rsp_fsm = XRAM_RSP_INVAL;
         else                                     r_xram_rsp_fsm = XRAM_RSP_WRITE_DIRTY;
-      }
+        m_cpt_xram_rsp_fsm_n_trt_lock++;
+      }
+
+      m_cpt_xram_rsp_fsm_trt_lock++;
+
       break;
     }
@@ -4009,5 +4577,12 @@
         r_xram_rsp_to_tgt_rsp_srcid = r_xram_rsp_trt_buf.srcid;
         r_xram_rsp_to_tgt_rsp_trdid = r_xram_rsp_trt_buf.trdid;
-        r_xram_rsp_to_tgt_rsp_pktid = r_xram_rsp_trt_buf.pktid;
+        if (r_xram_rsp_coherent.read())
+        {
+          r_xram_rsp_to_tgt_rsp_pktid = 0x0 + r_xram_rsp_trt_buf.pktid;//RWT CC
+        }
+        else
+        {
+          r_xram_rsp_to_tgt_rsp_pktid = 0x8 + r_xram_rsp_trt_buf.pktid;//RWT NCC
+        }
         for(size_t i=0; i < m_words; i++)
         {
@@ -4019,4 +4594,5 @@
         r_xram_rsp_to_tgt_rsp_rerror = false;
         r_xram_rsp_to_tgt_rsp_req    = true;
+      
 
         if(r_xram_rsp_victim_inval)      r_xram_rsp_fsm = XRAM_RSP_INVAL;
@@ -4073,5 +4649,5 @@
     case XRAM_RSP_WRITE_DIRTY:  // send a write request to IXR_CMD FSM
     {
-      if(!r_xram_rsp_to_ixr_cmd_req.read())
+      if(!r_xram_rsp_to_ixr_cmd_req.read() and !r_xram_rsp_to_ixr_cmd_inval_ncc_pending.read())
       {
         r_xram_rsp_to_ixr_cmd_req = true;
@@ -4081,6 +4657,15 @@
         {
             r_xram_rsp_to_ixr_cmd_data[i] = r_xram_rsp_victim_data[i];
+              std::cout << "data L2 = " << std::hex << r_xram_rsp_victim_data[i] << std::dec << std::endl;
         }
         m_cpt_write_dirty++;
+        
+        if ((!r_xram_rsp_victim_coherent.read()) and (r_xram_rsp_victim_count.read() == 1)) //if NCC, we save the data in case of not dirty L1
+        {
+          r_xram_rsp_to_ixr_cmd_req = false;
+          r_xram_rsp_to_ixr_cmd_inval_ncc_pending = true;
+          r_xram_rsp_fsm = XRAM_RSP_IDLE;
+          break;
+        }
 
         bool multi_req = !r_xram_rsp_victim_is_cnt.read() and r_xram_rsp_victim_inval.read();
@@ -4105,4 +4690,5 @@
       {
         r_xram_rsp_fsm = XRAM_RSP_HEAP_ERASE;
+        m_cpt_xram_rsp_fsm_n_heap_lock++;
       }
 
@@ -4112,4 +4698,7 @@
           << " Requesting HEAP lock" << std::endl;
 #endif
+
+      m_cpt_xram_rsp_fsm_heap_lock++;
+
       break;
     }
@@ -4278,4 +4867,9 @@
       r_cleanup_inst  = (type == DspinDhccpParam::TYPE_CLEANUP_INST);
       r_cleanup_srcid = srcid;
+      r_cleanup_ncc = 
+        DspinDhccpParam::dspin_get(
+            flit,
+            DspinDhccpParam::CLEANUP_NCC);
+      r_cleanup_contains_data = false;
 
       if(srcid >= m_initiators)
@@ -4294,9 +4888,16 @@
 
 #if DEBUG_MEMC_CLEANUP
-if(m_debug)
-std::cout << "  <MEMC "         << name()
-          << " CLEANUP_IDLE> Cleanup request:" << std::hex
-          << " / owner_id = "   << srcid
-          << " / owner_ins = "  << (type == DspinDhccpParam::TYPE_CLEANUP_INST) << std::endl;
+      if(m_debug)
+      {
+        std::cout
+            << "  <MEMC "         << name()
+            << " CLEANUP_IDLE> Cleanup request:" << std::hex
+            << " / owner_id = "   << srcid
+            << " / owner_ins = "  << (type == DspinDhccpParam::TYPE_CLEANUP_INST)
+            << " / ncc = " << DspinDhccpParam::dspin_get(
+                                                          flit,
+                                                          DspinDhccpParam::CLEANUP_NCC)
+            << std::endl;
+      }
 #endif
       break;
@@ -4312,24 +4913,77 @@
       addr_t nline = r_cleanup_nline.read() |
         DspinDhccpParam::dspin_get(flit, DspinDhccpParam::CLEANUP_NLINE_LSB);
-
+      
+      //A MODIFIER POUR DIRTY //
+      bool eop =
+        DspinDhccpParam::dspin_get(flit, DspinDhccpParam::P2M_EOP) == 0x1;
+      if (! eop)
+      {
+        r_cleanup_fsm = CLEANUP_GET_DATA;
+        r_cleanup_data_index = 0;
+        r_cleanup_contains_data = true;
+      }
+      else
+      {
+        r_cleanup_fsm = CLEANUP_DIR_REQ;
+      }
       cc_receive_to_cleanup_fifo_get = true;
-      r_cleanup_nline                = nline;
-      r_cleanup_fsm                  = CLEANUP_DIR_REQ;
+      r_cleanup_nline               = nline;
 
 #if DEBUG_MEMC_CLEANUP
-if(m_debug)
-std::cout << "  <MEMC "         << name()
-          << " CLEANUP_GET_NLINE> Cleanup request:"
-          << " / address = " << std::hex << nline * m_words * 4 << std::endl;
-#endif
-      break;
-    }
-
+      if(m_debug)
+      {
+        std::cout
+            << "  <MEMC "         << name()
+            << " CLEANUP_GET_NLINE> Cleanup request:"
+            << std::hex
+            << " / address = "    << nline * m_words * 4
+            << " / contains data = " << (!eop)
+            << std::endl;
+      }
+#endif
+      break;
+    }
+    /////////////////////
+    case CLEANUP_GET_DATA :
+    {
+      if (m_cc_receive_to_cleanup_fifo.rok())
+      {
+        uint64_t flit = m_cc_receive_to_cleanup_fifo.read();
+  
+        uint32_t data = 
+          DspinDhccpParam::dspin_get (flit, DspinDhccpParam::CLEANUP_DATA_UPDT);
+  
+        r_cleanup_data[r_cleanup_data_index] = data;
+        r_cleanup_data_index = r_cleanup_data_index.read() + 1;
+        assert (r_cleanup_data_index.read() < m_words and "MEM_CACHE in CLEANUP_GET_DATA : too much flits in cleanup data updt");
+        cc_receive_to_cleanup_fifo_get = true;
+        if (r_cleanup_data_index.read() == m_words - 1)
+        {
+          r_cleanup_contains_data = true;
+          m_cpt_cleanup_data ++;
+          r_cleanup_fsm = CLEANUP_DIR_REQ;
+        }
+#if DEBUG_MEMC_CLEANUP
+      if(m_debug)
+      {
+        std::cout
+            << "  <MEMC "         << name()
+            << " CLEANUP_GET_DATA> "
+            << " / word = "    << std::dec << r_cleanup_data_index.read()
+            << " / data = " << std::hex << data
+            << std::endl;
+      }
+#endif
+      }
+      break;
+    }
     /////////////////////
     case CLEANUP_DIR_REQ:   // Get the lock to the directory
     {
+      m_cpt_cleanup_fsm_dir_lock++;
       if(r_alloc_dir_fsm.read() != ALLOC_DIR_CLEANUP) break;
 
       r_cleanup_fsm = CLEANUP_DIR_LOCK;
+      //std::cout << " MEM_CACHE : CLEANUP_DIR_REQ" << std::endl;
 
 #if DEBUG_MEMC_CLEANUP
@@ -4337,4 +4991,7 @@
 std::cout << "  <MEMC " << name() << " CLEANUP_DIR_REQ> Requesting DIR lock" << std::endl;
 #endif
+
+      m_cpt_cleanup_fsm_n_dir_lock++;
+
       break;
     }
@@ -4353,4 +5010,5 @@
         exit(0);
       }
+      //std::cout << " MEM_CACHE : CLEANUP_DIR_LOCK" << std::endl;
 
       // Read the directory
@@ -4371,4 +5029,11 @@
       r_cleanup_copy_cache   = entry.owner.cache_id;
 #endif
+
+      //RWT
+      size_t set = m_y[(addr_t)(cleanup_address)];
+      m_cache_data.read_line(way, set, r_cleanup_old_data); 
+      r_cleanup_coherent = entry.cache_coherent;
+
+
 
       if(entry.valid)      // hit : the copy must be cleared
@@ -4420,4 +5085,5 @@
     case CLEANUP_DIR_WRITE:
     {
+      /*ODCCP*///std::cout << "CLEANUP_DIR_WRITE" << std::endl;
       // Update the directory entry without heap access
       if(r_alloc_dir_fsm.read() != ALLOC_DIR_CLEANUP)
@@ -4453,23 +5119,86 @@
       }
 
+      /*RWT*/
+      bool   inval_request = (r_read_to_cleanup_req.read() and (r_cleanup_nline.read() == r_read_to_cleanup_nline.read())) // NCC to CC initiated by a read transaction
+                          or (r_write_to_cleanup_req.read() and (r_cleanup_nline.read() == r_write_to_cleanup_nline.read())); //NCC to CC initiated by a wrtie transaction
+
+
+      if (inval_request) m_cpt_ncc_to_cc ++;
+
+      if (r_write_to_cleanup_req.read() and (r_cleanup_nline.read() == r_write_to_cleanup_nline.read()))
+      {
+        r_write_to_cleanup_req = false;
+        m_cpt_ncc_to_cc_write ++;
+      }
+
+
       // update the cache directory (for the copies)
       DirectoryEntry entry;
-      entry.valid       = true;
-      entry.is_cnt      = r_cleanup_is_cnt.read();
-      entry.dirty       = r_cleanup_dirty.read();
-      entry.tag         = r_cleanup_tag.read();
-      entry.lock        = r_cleanup_lock.read();
-      entry.ptr         = r_cleanup_ptr.read();
-      entry.count       = r_cleanup_count.read() - 1;
-      entry.owner.srcid = 0;
-      entry.owner.inst  = 0;
-
+      entry.valid          = true;
+      entry.cache_coherent = inval_request or r_cleanup_coherent.read();
+      entry.is_cnt         = r_cleanup_is_cnt.read();
+      entry.dirty          = r_cleanup_dirty.read() or r_cleanup_contains_data.read();
+      entry.tag            = r_cleanup_tag.read();
+      entry.lock           = r_cleanup_lock.read();
+      entry.ptr            = r_cleanup_ptr.read();
+      if (r_read_to_cleanup_req.read() and (r_cleanup_nline.read() == r_read_to_cleanup_nline.read())) //pending READ 
+      {
+        if (r_read_to_cleanup_cached_read.read())
+        {
+          entry.count          = r_cleanup_count.read();
+          entry.owner.srcid    = r_read_to_cleanup_srcid.read();
+          entry.owner.inst     = 0;
 #if L1_MULTI_CACHE
-      entry.owner.cache_id = 0;
-#endif
+          entry.owner.cache_id = r_cleanup_copy_cache.read();
+#endif
+        }
+        else
+        {
+          entry.count          = r_cleanup_count.read() - 1;
+          entry.owner.srcid    = r_cleanup_copy.read();
+          entry.owner.inst     = r_cleanup_copy_inst.read();
+#if L1_MULTI_CACHE
+          entry.owner.cache_id = r_cleanup_copy_cache.read();
+#endif
+        }
+        if (r_read_to_cleanup_is_ll.read())
+        {
+          r_cleanup_to_tgt_rsp_ll_key = r_read_to_cleanup_ll_key.read();
+        }
+      }
+      else
+      {
+        entry.count          = r_cleanup_count.read() - 1;
+        entry.owner.srcid    = 0;
+        entry.owner.inst     = 0;
+#if L1_MULTI_CACHE
+        entry.owner.cache_id = 0;
+#endif
+      }
+
+
+      if (r_cleanup_contains_data.read())
+      {
+        for (size_t word = 0; word < m_words; word ++)
+        {
+          m_cache_data.write(way, set, word, r_cleanup_data[word].read(), 0xF);
+        }
+        m_llsc_table.sw(r_cleanup_nline.read());
+        //m_llsc_table.sw(r_cleanup_nline.read()*m_words*4);
+      }
+
 
       m_cache_directory.write(set, way, entry);
 
-      r_cleanup_fsm = CLEANUP_SEND_CLACK;
+
+      /*RWT*/
+      if (inval_request)
+      {
+        r_cleanup_fsm = CLEANUP_IVT_LOCK_DATA;
+      }
+      else
+      {
+        r_cleanup_fsm = CLEANUP_SEND_CLACK;
+      }
 
 #if DEBUG_MEMC_CLEANUP
@@ -4485,4 +5214,5 @@
             << " / count = "   << entry.count
             << " / is_cnt = "  << entry.is_cnt
+            << " / match_inval = " << inval_request
             << std::endl;
       }
